#!/usr/bin/perl -w
# Skrypt uruchamia komende, czeka az komenda sie zakonczy lub minie timeout.
# Jesli komenda sie zakonczy w zadanym czasie, zwraca taki kod, jak ta komenda;
# jesli komenda dalej dziala - KILLuje ja najpierw SIGTERMem, potem SIGKILLem
# jesli to nie pomoze i zwraca kod 1 (jesli wystarczyl SIGTERM) lub kod 2 (SIGKILL byl konieczny).


use strict;
use Getopt::Std;
use POSIX;
#use POSIX ":sys_wait_h";

our($opt_t);
getopts('t:');

if (defined($opt_t) && defined($ARGV[0])) {
  #print "$opt_t\n";
  #print $ARGV[0]."\n";
  my $pid = fork();
  die "fork() failed: $!" unless defined $pid;
  if ($pid) {
    # Jestem tatusiem!
    my $countdown = int($opt_t);
    if (!$countdown > 0 ) {
      die("Bad timeout value!\n");
    }
    for ($countdown = int($opt_t); $countdown > 0; $countdown--) {
      #print "$countdown\n";
      sleep 1;
      my $kid = waitpid($pid, WNOHANG);
      my $status = $?;
      if ($kid == 0) {
        #print "Dziecko dziala\n";
      } else {
        my $retval = ($status >> 8);
        #print "Retval: $retval\n";
        #$?>> 8
        exit $retval;
      }
    }
    # Minal timeout, a dziecko caly czas dziala
    # Killujemy zatem:
    kill SIGTERM, $pid;
    sleep 2;
    my $kid = waitpid($pid, WNOHANG);
    my $status = $?;
    if ($kid == 0) {
      print STDERR "Child is STILL working, SIGKILL...\n";
      kill SIGKILL, $pid;
      exit 2;
    } else {
        my $retval = ($status >> 8);
        #print "Retval: $retval\n";
        #exit $retval;
        exit 1;
    }
  }
  else {
    # Da-da!
    exec(@ARGV) or die("Couldn't exec: ".join(' ', @ARGV));
    exit(0);
  }
  
} else {
  print STDERR "Usage:\n$0 -t timeout command [args] \n";
}

